"use client"
import { useState, useEffect } from "react";
//import data from '@helpers/quotes.json';

import metadata from '@metadata.json';
import html2canvas from 'html2canvas';



function Page() {

		const [quote, setQuote] = useState("load");
		const [data, setData] = useState(false);

		useEffect(() => {
			async function getfetch () {
				const response = await fetch(metadata.hostname+'api/quotes/coaches');
				const result = await response.json();
				return result;
			};
			getfetch()
				.then((xdata) => {
					console.log('data fetched', xdata);
					setData(xdata);
				})
			/*
			*/
		}, []);

		useEffect(() => {
			console.log('random call');
			random();
		}, [data]);



		async function download() {
				document.getElementById('mockup-quote-show').style.display = 'none';
				document.getElementById('mockup-quote-canvas').style.display = 'block';
				await html2canvas(document.getElementById('mockup-quote-canvas')).then(function(canvas) {
						console.log('finish rendering');
						const dataURL = canvas.toDataURL('image/png');
						const a = document.createElement('a');
						a.href = dataURL;
						a.download = metadata.name+`-quote.png`;
						a.click();
				});
				document.getElementById('mockup-quote-show').style.display = 'block';
				document.getElementById('mockup-quote-canvas').style.display = 'none';
		}

		function share() {
		
		
		}


		const quotesSVG = (
						<svg xmlns="http://www.w3.org/2000/svg" viewBox="0 0 32 32">
							<g>
								<path d="M6.67 26.06c.09 0 8.77-.14 8.77-11.89a7.22 7.22 0 10-9.77 6.73v4.16a1 1 0 001 1zM3 14.17a5.22 5.22 0 1110.44 0c0 7.5-3.88 9.31-5.77 9.75v-3.75a1 1 0 00-.75-1 5.21 5.21 0 01-3.92-5z"></path>
								<path d="M22.22 26.06c.09 0 8.78-.14 8.78-11.89a7.22 7.22 0 10-9.78 6.73v4.16a1 1 0 001 1zm-3.66-11.89a5.22 5.22 0 1110.44 0c0 7.5-3.89 9.31-5.78 9.75v-3.75a1 1 0 00-.75-1 5.21 5.21 0 01-3.91-5z"></path>
							</g>
						</svg>
		);

		const random = () => {
				if (data) {
						setQuote(data[Math.floor(Math.random() * data.length)]);
				}
		}


			return (
				<>
						{
							!data && quote === "load" ? (
								<>
									<div className="min-h-screen flex items-center justify-center content-center p-4">
										 <div className="lds-grid"><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div><div></div></div>
									</div>
								</>
							):(
										<>
												<div id="mockup-quote-show" className="mockup-window border bg-base-300 w-full">
													<div className="flex justify-center px-4 py-16 bg-base-200 text-2xl font-bold"><div>{quote.quote ?? "^^"}      - <span className="badge badge-lg badge-accent">{quote.from??"^^^^^"}</span></div></div>
												</div>
												<div style={{display:'none'}} id="mockup-quote-canvas" className="mockup-window border bg-base-300 w-full">
													<div className="flex justify-center px-4 py-16 bg-base-200 text-2xl font-bold"><div>{quote.quote ?? "^^"}<br/><br/><i className="">{quote.from??"^^^^^"}</i></div></div>
													<h4 className="p-[0.5em] pb-[1.4em] font-bold text-lg" >Generated in {metadata.name}</h4>
												</div>
												<div className="flex flex-wrap flex-row container m-auto w-auto">
														<button onClick={random} className="btn btn-secondary m-2">New one</button>
														<button className="btn btn-secondary m-2" onClick={share}>Share</button>
														<button className="btn btn-secondary m-2" onClick={async()=>{await download()}}>Download</button>
												</div>
				  							<canvas id="quotes-canvas" style={{display:"none"}}></canvas>
				  					</>
							)
						}
				</>
		);


}

export default Page;
